//+------------------------------------------------------------------+
//|Cronex_TaichiMPsw_mtf                           Cronex Taichi.mq4 |
//|Price; SepWindow      Copyright  2004, MetaQuotes Software Corp. |
//|(MTF ForexTSD.com 2007)mladen fxbs     http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, Cronex"
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
//#property  indicator_chart_window
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  SlateGray
#property  indicator_color2  LimeGreen
#property  indicator_color3  Crimson
#property  indicator_color4  Sienna
#property  indicator_color5  MediumSlateBlue
#property  indicator_color6  MediumSlateBlue
#property  indicator_color7  DarkGreen
#property  indicator_width1  2
#property  indicator_width2  3
#property  indicator_width3  3
#property  indicator_width4  2
#property  indicator_width5  3
#property  indicator_width6  3
#property  indicator_width7  1
//---- indicator parameters

extern int Tenkan=9;
extern int Kijun=26;
extern int Senkou=52;
extern string     ____ = "_____";
extern int TimeFrame = 60;
extern string note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN";
extern string     _____ = "_____";
extern string  IndicatorCorrectName = "Cronex_TaichiMPsw_mtf";
extern string  note___Ind_Name = "if ind.Name changed - enter New Name";

//---- indicator buffers
double     TaichiBuffer[];    //Silver
double     TaichiForBuffer[]; //Red
double     SignalBuffer[];    //Lime
double     SSignalBuffer[];   //DarkOrange
double     FlatBuffer1[];     //DeepSkyBlue
double     FlatBuffer2[];     //DeepSkyBlue
double     ChinkouBuffer[];   //DarkGreen


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);

//   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,TaichiBuffer);  //=(Tenkan+Kijun+SenkouSpA+SenkouSpB)/4;
   SetIndexBuffer(1,SignalBuffer);   //=iMAOnArray(TaichiBuffer,Bars, Kijun, 0,MODE_LWMA,i);
   SetIndexBuffer(2,SSignalBuffer); //=iMAOnArray(TaichiBuffer,Bars, Senkou, 0,MODE_LWMA,i);  
   SetIndexBuffer(3,TaichiForBuffer);//=(SenkouSpanA+SenkouSpanB)/2;
   SetIndexBuffer(4,FlatBuffer1);
   SetIndexBuffer(5,FlatBuffer2);
   SetIndexBuffer(6,ChinkouBuffer);

   SetIndexShift(3,Kijun);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Cronex Taichi["+TimeFrame+"]("+Tenkan+","+Kijun+","+Senkou+"");
   SetIndexLabel(0,"Taichi");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"SSignal");
   SetIndexLabel(3,"TaichiFor");
   SetIndexLabel(4,"Flat1");
   SetIndexLabel(5,"Flat2");
   SetIndexLabel(6,"Chinkou"); 

//---- initialization done
    if (TimeFrame < Period()) TimeFrame = Period();
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
  
   double TenkanSen,KijunSen,SenkouSpanA,SenkouSpanB,ChinkouSpan;
  //
   int counted_bars1=IndicatorCounted();
   int      limit1,i1;
   if(counted_bars1 < 0) return(-1);
   limit1 = Bars-counted_bars1;
   if (TimeFrame != Period())
      {
         limit1 = MathMax(limit1,TimeFrame/Period());
         datetime TimeArray[];
        ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
            for(i1=0,int y=0; i1<limit1; i1++)
           {
              if(Time[i1]<TimeArray[y]) y++;
              TaichiBuffer   [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,0,y);
              SignalBuffer   [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,1,y);
              SSignalBuffer  [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,2,y);
              TaichiForBuffer[i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,3,y);
              FlatBuffer1    [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,4,y);
              FlatBuffer2    [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,5,y);
              ChinkouBuffer  [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,6,y);      

            }
         return(0);         
      }
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 
   for(int i=-Kijun; i<limit; i++)
      {
//      TaichiBuffer[i]=(iRSI(NULL,0,FastEMA,PRICE_OPEN,i)+iRSI(NULL,0,SlowEMA,PRICE_OPEN,i)+)/2;   
//      TaichiBuffer[i]=iRSI(NULL,0,SlowEMA,PRICE_OPEN,i);

      TenkanSen   = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_TENKANSEN,i);
      KijunSen    = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_KIJUNSEN,i);
      SenkouSpanA = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANA,i);
      SenkouSpanB = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANB,i);
      ChinkouSpan = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_CHINKOUSPAN,i);      
      if(ChinkouSpan>0)    ChinkouBuffer[i-Kijun]=ChinkouSpan;

      if (i>=0)
       {
        TaichiBuffer[i]=(TenkanSen+KijunSen+SenkouSpanA+SenkouSpanB)/4;
        TaichiForBuffer[i+Kijun]=(SenkouSpanA+SenkouSpanB)/2;
       }
      else TaichiForBuffer[i+Kijun]=(SenkouSpanA+SenkouSpanB)/2;
      }
//========================== signal line counted ================
   for(i=0; i<limit; i++)
    {
     SignalBuffer[i]=iMAOnArray(TaichiBuffer,Bars,Kijun,0,MODE_LWMA,i);
     SSignalBuffer[i]=iMAOnArray(TaichiBuffer,Bars,Senkou,0,MODE_LWMA,i);   

   if( MathAbs(((TaichiBuffer[i]-SignalBuffer[i])+(TaichiBuffer[i]-
                  SSignalBuffer[i])+(SignalBuffer[i]-SSignalBuffer[i]))/3)<Tenkan*Point)
   FlatBuffer1[i]=SignalBuffer[i]+Kijun*Point;
   if( MathAbs(((TaichiBuffer[i]-SignalBuffer[i])+(TaichiBuffer[i]-
                  SSignalBuffer[i])+(SignalBuffer[i]-SSignalBuffer[i]))/3)<Tenkan*Point)
        FlatBuffer2[i]=SignalBuffer[i] -Kijun*Point;







    }
//---- done

   return(0);
  }

  
//+------------------------------------------------------------------+